require 'spec_helper'

describe "Polygon" do

  it 'test can build a polygon from an array of points' do

    points = JSON.parse("[[100.0, 0.0], [101.0, 0.0], [101.0, 1.0], [100.0, 1.0], [100.0, 0.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.vertices.length.should == points.length
    polygon.vertices[0].x.should == points[0][0]

  end

  it 'test is polygon simple 1' do

    points = JSON.parse("[[100.0, 0.0], [101.0, 0.0], [101.0, 1.0], [100.0, 1.0], [100.0, 0.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == true

  end

  it 'test is polygon simple 2' do

    points = JSON.parse("[[2.0, 2.0], [1.0, 2.0], [1.0, 1.0], [2.0, 1.0], [3.0, 1.0], [3.0, 2.0], [2.0, 2.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == true

  end

  it 'test is polygon simple 3' do

    points = JSON.parse("[[0, 0], [0, 1], [1, 1], [1, 0], [0, 0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == true

  end

  it 'test is polygon simple 4' do

    points = JSON.parse("[[0.0, 0.0], [0.0, 3.0], [3.0, 3.0], [3.0, 0.0], [0.0, 0.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == true

  end

  it 'test is polygon simple 5' do

    points = JSON.parse("[[2.0, 2.0], [2.0, 3.0], [3.0, 3.0], [4.0, 3.0], [4.0, 2.0], [2.0, 2.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == true

  end

  it 'test is practical polygon simple 6 (clockwise)' do

    points = JSON.parse("[[-110.84096146619905, 32.206464264983815],[-110.8254844632264, 32.206404507969239],[-110.82564474991523, 32.2065185890533],[-110.8278203157768, 32.211149692139429],[-110.82920840010047, 32.217701622983441],[110.82990196985523,32.220975019031748],[-110.84096004697494,32.221011891029775],[-110.84096146619905,32.206464264983815]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == true

  end

  it 'test is practical polygon simple 7 (counter clockwise)' do

    points = JSON.parse("[[-118.845766, 34.013743],[-118.384777,34.013743],[-118.384777, 34.335579],[-118.845766, 34.335579],[-118.845766, 34.013743]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == true

  end


  it 'get_intersection_point_hash test for practical polygon simple 6 (clockwise)' do

    points = JSON.parse("[[-110.84096146619905, 32.206464264983815],[-110.8254844632264, 32.206404507969239],[-110.82564474991523, 32.2065185890533],[-110.8278203157768, 32.211149692139429],[-110.82920840010047, 32.217701622983441],[110.82990196985523,32.220975019031748],[-110.84096004697494,32.221011891029775],[-110.84096146619905,32.206464264983815]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.get_first_intersection_point_hash.should be_nil

  end

  it 'get_intersection_point_hash test for practical polygon simple 6 (counter clockwise)' do

    points = JSON.parse("[[-118.845766, 34.013743],[-118.384777,34.013743],[-118.384777, 34.335579],[-118.845766, 34.335579],[-118.845766, 34.013743]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.get_first_intersection_point_hash.should be_nil

  end

  it 'test is practical polygon simple 7 (counter clockwise)' do

    points = JSON.parse("[[-118.845766, 34.013743],[-118.384777,34.013743],[-118.384777, 34.335579],[-118.845766, 34.335579],[-118.845766, 34.013743]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == true

  end


  it 'test is complex polygon 1' do

    points = JSON.parse("[[100.0, 0.0],[101.0, 1.0],[100.0, 1.0],[101.0, 0.0], [100.0, 0.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == false

  end

  it 'test is complex polygon 2' do

    points = JSON.parse("[[2.0, 2.0], [3.0, 2.0], [3.0, 3.0], [4.0, 1.0],[2.0, 3.0], [2.0, 2.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == false

  end

  it 'test is complex polygon 3' do

    points = JSON.parse("[[0.0, 0.0], [3.0, 3.0], [0.0, 3.0], [3.0, 0.0], [0.0, 0.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == false

  end


  it 'test is practical complex polygon 4' do

    points = JSON.parse("[[-98.4609375000036,40.3051841980949],[-98.4609375000036,38.057277897745],[-96.0878906250017,40.1038062719331],[-96.6152343750031,37.9880405545487],[-98.4609375000036,40.3051841980949]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == false

  end

  it 'test is production complex polygon 1' do

    #points = JSON.parse("[[41.96514,-87.80356],[41.96182,-87.80115],[41.96156,-87.79909],[41.96131,-87.79635],[41.96105,-87.79394],[41.9608,-87.79188],[41.95978,-87.78914],[41.95876,-87.78708],[41.95722,-87.78467],[41.95544,-87.78193],[41.95339,-87.77987],[41.9511,-87.77781],[41.94803,-87.77541],[41.94446,-87.773],[41.94063,-87.7706],[41.9368,-87.76785],[41.93271,-87.76545],[41.92658,-87.76339],[41.91687,-87.76133],[41.87522,-87.76373],[41.87445,-87.76579],[41.87394,-87.76854],[41.87368,-87.7706],[41.87343,-87.77335],[41.87266,-87.77575],[41.8724,-87.77815],[41.87215,-87.78021],[41.87164,-87.78296],[41.87113,-87.78536],[41.87113,-87.78776],[41.87113,-87.78982],[41.87113,-87.79223],[41.87113,-87.79463],[41.87113,-87.79703],[41.87138,-87.79978],[41.87189,-87.80184],[41.8724,-87.8039],[41.87317,-87.8063],[41.87419,-87.80871],[41.87471,-87.81077],[41.87547,-87.81283],[41.87649,-87.81523],[41.87726,-87.81729],[41.87752,-87.81935],[41.87777,-87.82141],[41.87803,-87.82347],[41.87828,-87.82622],[41.87854,-87.82862],[41.87854,-87.83171],[41.8788,-87.83377],[41.87931,-87.83652],[41.88007,-87.83926],[41.88058,-87.84132],[41.88135,-87.84373],[41.88237,-87.84613],[41.88365,-87.84888],[41.88493,-87.85094],[41.88697,-87.85334],[41.89055,-87.8554],[41.89515,-87.85746],[41.90026,-87.85952],[41.90435,-87.86158],[41.92913,-87.85952],[41.93373,-87.85746],[41.94139,-87.8554],[41.94573,-87.85334],[41.94778,-87.85094],[41.94905,-87.84888],[41.95059,-87.84647],[41.95263,-87.84304],[41.95365,-87.84098],[41.95442,-87.83892],[41.95671,-87.83514],[41.95773,-87.83308],[41.95901,-87.83102],[41.96003,-87.82862],[41.96207,-87.82484],[41.9631,-87.82107],[41.9631,-87.81901],[41.9631,-87.81695],[41.9631,-87.81351],[41.96284,-87.81042],[41.96233,-87.80699],[41.96207,-87.80424],[41.96156,-87.80184],[41.96105,-87.79978],[41.95901,-87.79703],[41.96514,-87.80356]]")
    points = JSON.parse("[[-87.80356,41.96514],[-87.80115,41.96182],[-87.79909,41.96156],[-87.79635,41.96131],[-87.79394,41.96105],[-87.79188,41.9608],[-87.78914,41.95978],[-87.78708,41.95876],[-87.78467,41.95722],[-87.78193,41.95544],[-87.77987,41.95339],[-87.77781,41.9511],[-87.77541,41.94803],[-87.773,41.94446],[-87.7706,41.94063],[-87.76785,41.9368],[-87.76545,41.93271],[-87.76339,41.92658],[-87.76133,41.91687],[-87.76373,41.87522],[-87.76579,41.87445],[-87.76854,41.87394],[-87.7706,41.87368],[-87.77335,41.87343],[-87.77575,41.87266],[-87.77815,41.8724],[-87.78021,41.87215],[-87.78296,41.87164],[-87.78536,41.87113],[-87.78776,41.87113],[-87.78982,41.87113],[-87.79223,41.87113],[-87.79463,41.87113],[-87.79703,41.87113],[-87.79978,41.87138],[-87.80184,41.87189],[-87.8039,41.8724],[-87.8063,41.87317],[-87.80871,41.87419],[-87.81077,41.87471],[-87.81283,41.87547],[-87.81523,41.87649],[-87.81729,41.87726],[-87.81935,41.87752],[-87.82141,41.87777],[-87.82347,41.87803],[-87.82622,41.87828],[-87.82862,41.87854],[-87.83171,41.87854],[-87.83377,41.8788],[-87.83652,41.87931],[-87.83926,41.88007],[-87.84132,41.88058],[-87.84373,41.88135],[-87.84613,41.88237],[-87.84888,41.88365],[-87.85094,41.88493],[-87.85334,41.88697],[-87.8554,41.89055],[-87.85746,41.89515],[-87.85952,41.90026],[-87.86158,41.90435],[-87.85952,41.92913],[-87.85746,41.93373],[-87.8554,41.94139],[-87.85334,41.94573],[-87.85094,41.94778],[-87.84888,41.94905],[-87.84647,41.95059],[-87.84304,41.95263],[-87.84098,41.95365],[-87.83892,41.95442],[-87.83514,41.95671],[-87.83308,41.95773],[-87.83102,41.95901],[-87.82862,41.96003],[-87.82484,41.96207],[-87.82107,41.9631],[-87.81901,41.9631],[-87.81695,41.9631],[-87.81351,41.9631],[-87.81042,41.96284],[-87.80699,41.96233],[-87.80424,41.96207],[-87.80184,41.96156],[-87.79978,41.96105],[-87.79703,41.95901],[-87.80356,41.96514]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.is_simple.should == false

  end

  it 'get complex polygon 3 intersection points' do

    points = JSON.parse("[[0.0, 0.0], [3.0, 3.0], [0.0, 3.0], [3.0, 0.0], [0.0, 0.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.get_intersection_points[0].should == WindingPolygon::Point.new(1.5,1.5)

  end

  it 'get practical complex polygon 4 intersection points' do

    points = JSON.parse("[[-98.4609375000036,40.3051841980949],[-98.4609375000036,38.057277897745],[-96.0878906250017,40.1038062719331],[-96.6152343750031,37.9880405545487],[-98.4609375000036,40.3051841980949]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.get_intersection_points[0].should == WindingPolygon::Point.new(-97.39951856124108,38.97265129300353)

  end

  it 'get_intersection_point_hash test for practical complex polygon' do

    points = JSON.parse("[[-98.4609375000036,40.3051841980949],[-98.4609375000036,38.057277897745],[-96.0878906250017,40.1038062719331],[-96.6152343750031,37.9880405545487],[-98.4609375000036,40.3051841980949]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.get_first_intersection_point_hash.should == {:point=>WindingPolygon::Point.new(-97.39951856124108,38.97265129300353),:edge1=>3,:edge2=>1 }

  end

  it 'get practical complex polygon 5 intersection points' do

    points = JSON.parse("[[-98.4609375000036,40.3051841980949],[-98.4609375000036,38.057277897745],[-96.0878906250017,40.1038062719331],[-96.6152343750031,37.9880405545487],[-97.6152343750031,40.9880405545487],[-98.0152343750031,37.9880405545487],[-98.4609375000036,40.3051841980949]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    polygon.get_intersection_points.size.should == 3

  end

  it 'get practical complex polygon 6 intersection points' do

    points = JSON.parse("[["+"-115.86328125000495 34.15328996737699,-119.818359375002 45.45290147989422,-81.4101562500034 35.021556836103684,-110.50195312500117 46.97322061018078,-92.66015625000608 43.38159203778072,-94.68164062500398 46.18790776409503,-115.07226562500733 41.63237589430056,-104.17382812500229 40.17099871188528,-100.3945312500027 32.46399995947513,-95.82421875000551 37.08201838643584,-88.52929687500257 35.95188058401679,-84.31054687500303 33.64262887366194,-83.16796875000327 34.51617009551454,-82.37695312500296 32.538125275571225,-84.31054687500303 39.36031127050692,-72.79687500000323 42.739443407624286,-115.86328125000495 34.15328996737699".gsub(',','],[').gsub(' ',',')+"]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})

    intersection_points = polygon.get_intersection_points
    intersection_points.size.should == 8
    polygon.simple_segments.size == 32


  end

end