require 'spec_helper'

describe "Segment" do

  it "test_segments_intersect_at_the_endpoint" do

      segment1 = WindingPolygon::Segment.new({:edge=>0})
      segment1.left_point = WindingPolygon::Point.new(0,0)
      segment1.right_point = WindingPolygon::Point.new(2,2)

      segment2 = WindingPolygon::Segment.new({:edge=>1})
      segment2.left_point = WindingPolygon::Point.new(0,2)
      segment2.right_point = WindingPolygon::Point.new(2,2)

      intersection_point = segment1.intersection_point_with(segment2)
      intersection_point.x.should ==2
      intersection_point.y.should ==2

  end

  it "point is on the line segment" do

    segment1 = WindingPolygon::Segment.new({:edge=>0})
    segment1.left_point = WindingPolygon::Point.new(0,0)
    segment1.right_point = WindingPolygon::Point.new(3,3)

    segment1.is_on_the_line(WindingPolygon::Point.new(1.5,1.5)).should == true
    segment1.is_on_the_line(WindingPolygon::Point.new(1.5,2.5)).should == false
    segment1.is_on_the_line(WindingPolygon::Point.new(3.5,3.5)).should == false

  end
end