require 'spec_helper'

describe "SweepLine" do

  it "test can find" do
    points = JSON.parse("[[100.0, 0.0], [101.0, 0.0], [101.0, 1.0], [100.0, 1.0], [100.0, 0.0]]")
    polygon = WindingPolygon::Polygon.new(points.map{|item| WindingPolygon::Point.new(item[0],item[1])})
    sweep_line = WindingPolygon::SweepLine.new(polygon)
    event_queue = WindingPolygon::EventQueue.new(polygon)

    event = event_queue.events.shift
    while !event.nil?
        if event[:type]=='left'
          sweep_line.add(event)
          sweep_line.find(event).should_not be_nil
        else
          seg = sweep_line.find(event)
          seg.should_not be_nil
          sweep_line.remove(seg)
        end
        event = event_queue.events.shift
    end

  end
end